﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using DependentGridInTab.Classes;
using Infragistics.Windows.DataPresenter;
using System.Globalization;

namespace DependentGridInTab
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DBOperation objDB;
        DataSet ds,objDs;
        DataTable objCourseTable,objFacultyTable;
        DataRow dr;
        public MainWindow()
        {
            InitializeComponent();
            objDB = new DBOperation();
            

        }

        private void InitializeDataTable()
        {
            objCourseTable = new DataTable("Courses");

            objCourseTable.Columns.Add("CourseID", typeof(string));
            objCourseTable.Columns.Add("CourseName", typeof(string));
            objCourseTable.Columns.Add("Fee", typeof(string));

            objFacultyTable = new DataTable("Faculties");
            objFacultyTable.Columns.Add("FacultyID", typeof(string));
            objFacultyTable.Columns.Add("FacultyName", typeof(string));
            objFacultyTable.Columns.Add("CourseID", typeof(string));

            //objCourseTable.PrimaryKey = new DataColumn[] { objCourseTable.Columns[0] };
            //objFacultyTable.PrimaryKey = new DataColumn[] { objFacultyTable.Columns[0] };

            //ForeignKeyConstraint fkc = new ForeignKeyConstraint("fkCourseID", objCourseTable.Columns[0], objFacultyTable.Columns[2]);
            //objFacultyTable.Constraints.Add(fkc);

            dr = objCourseTable.NewRow();
            dr[0] = "C001";
            dr[1] = "Java";
            dr[2] = "12000";

            objCourseTable.Rows.Add(dr);
            dr = null;

            dr = objCourseTable.NewRow();
            dr[0] = "C002";
            dr[1] = "C#";
            dr[2] = "10000";

            objCourseTable.Rows.Add(dr);

            dr = objFacultyTable.NewRow();
            dr[0] = "F001";
            dr[1] = "Robin";
            dr[2] = "C001";

            objFacultyTable.Rows.Add(dr);
            dr = null;

            dr = objFacultyTable.NewRow();
            dr[0] = "F002";
            dr[1] = "Peter";
            dr[2] = "C002";

            objFacultyTable.Rows.Add(dr);

            dr = objFacultyTable.NewRow();
            dr[0] = "F003";
            dr[1] = "Nelson";
            dr[2] = "C001";

            objFacultyTable.Rows.Add(dr);

            objDs = new DataSet();
            objDs.Tables.Add(objCourseTable);
            objDs.Tables.Add(objFacultyTable);


            
        
        }
        public void FillData()
        {
            ds = objDB.GetAllCourseData();
        }
        public void FillDataForModuleGrid1()
        {
            ds = objDB.GetAllCourseData();
        }
        public void FillDataForModuleGrid2(string id)
        {
            if (ds.Tables.Count > 1)
                ds.Tables.RemoveAt(1);
            ds.Tables.Add(objDB.GetFacultyDataByCourseId(id).Tables[0].Copy());
        }



        private void FocusOnCourseNewRecord()
        {
            try
            {
                xamGridParent.Focus();
                if ((xamGridParent.RecordManager.CurrentAddRecord != null))
                {
                    xamGridParent.RecordManager.CurrentAddRecord.IsActive = true;
                    xamGridParent.RecordManager.CurrentAddRecord.IsSelected = true;
                    xamGridParent.RecordManager.CurrentAddRecord.Cells["CourseName"].IsActive = true;
                    xamGridParent.RecordManager.CurrentAddRecord.Cells["CourseName"].IsSelected = true;
                }
            }
            catch (Exception ex)
            {

            }
        }
        private void wndDemoProj_Loaded(object sender, RoutedEventArgs e)
        {

        }
        private void xamGridParent_PreviewKeyDown(object sender, KeyEventArgs e)
        {


            if ((e.KeyboardDevice.Modifiers == ModifierKeys.Control))
            {
                return;
            }

            XamDataGrid grid = (XamDataGrid)sender;

            //********************Only for New Rercords*********************************'
            if ((e.Key == Key.Return | e.Key == Key.Enter | e.Key == Key.Tab))
            {
                if ((grid.ActiveRecord != null && ((DataRecord)grid.ActiveRecord).IsAddRecord))
                {

                    if ((grid.ActiveCell != null) && (grid.ActiveCell.Field.Tag != null && grid.ActiveCell.Field.Tag.ToString().ToLower().Trim() == "lastcolumn"))
                    {
                        if ((grid.Name.ToLower() == "xamgridchild" && grid.ActiveCell.Field.Name.ToLower() == "FacultyName"))
                        {
                            if ((grid.ActiveCell.Value == null) || string.IsNullOrEmpty(grid.ActiveCell.Value.ToString()))
                            {
                                return;
                            }
                        }

                        grid.ExecuteCommand(DataPresenterCommands.EndEditModeAndAcceptChanges);

                        if ((e.Key == Key.Tab))
                        {
                            e.Handled = true;
                        }

                        grid.RecordManager.CommitAddRecord();


                        if (((grid.Name.ToLower() == "xamgridparent" && (grid.ActiveCell != null && grid.ActiveCell.Value != null) && (grid.ActiveCell.Value == null) == false && !string.IsNullOrEmpty(grid.ActiveCell.Value.ToString()))) || (grid.Name.ToLower() == "xamgridchild" && grid.ActiveCell != null && grid.ActiveCell.Field.Name.ToLower() == "facultyname"))
                        {
                            if ((grid.Name.ToLower() == "xamgridparent"))
                            {
                                FocusOnCourseNewRecord();
                            }

                            return;
                        }

                        grid.RecordManager.CurrentAddRecord.IsActive = true;
                        grid.RecordManager.CurrentAddRecord.IsSelected = true;

                        if ((grid.Tag != null && !string.IsNullOrEmpty(grid.Tag.ToString().Trim())))
                        {
                            if (grid.RecordManager.CurrentAddRecord.Index == -1)
                            {
                                FocusOnCourseNewRecord();
                                return;
                            }
                            if (grid.RecordManager.CurrentAddRecord.Index != -1)
                            {
                                grid.RecordManager.CurrentAddRecord.Cells[grid.Tag.ToString()].IsActive = true;
                                grid.RecordManager.CurrentAddRecord.Cells[grid.Tag.ToString()].IsSelected = true;
                            }
                        }

                        return;

                    }
                    else
                    {
                        e.Handled = true;
                        grid.ExecuteCommand(DataPresenterCommands.CellNext);
                        return;
                    }
                }
            }

        }
        private void xamGridParent_Loaded(object sender, RoutedEventArgs e)
        {
            FocusOnCourseNewRecord();
        }
        private void xamGridParent_RecordActivated(object sender, Infragistics.Windows.DataPresenter.Events.RecordActivatedEventArgs e)
        {

        }
        private void xamGridParent_RecordUpdating(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatingEventArgs e)
        {

        }
        private void xamGridParent_RecordDeactivating(object sender, Infragistics.Windows.DataPresenter.Events.RecordDeactivatingEventArgs e)
        {

        }

        private void xamGridParent_CellUpdated(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {
            if (e.Cell.Field.Name.ToLower() == "instructionsetname" && e.Cell.Value != null)
            {
                xamGridChild.DefaultFieldLayout.Fields["FacultyName"].Label = " Instructor for : " + e.Record.Cells["Course"].Value;
            }
        }

        private void btnCourseGridDelete_Click(object sender, RoutedEventArgs e)
        {

        }

        private void xamGridChild_PreviewKeyDown(object sender, KeyEventArgs e)
        {

        }

        private void xamGridChild_PreviewKeyDown_1(object sender, KeyEventArgs e)
        {

        }

        private void xamGridChild_RecordActivated(object sender, Infragistics.Windows.DataPresenter.Events.RecordActivatedEventArgs e)
        {

        }

        private void xamGridChild_RecordUpdating(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatingEventArgs e)
        {

        }

        private void xamGridChild_CellUpdated(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {

        }

        private void xamGridChild_InitializeTemplateAddRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeTemplateAddRecordEventArgs e)
        {

        }

        private void btnFacultyGridDelete_Click(object sender, RoutedEventArgs e)
        {

        }
        private void btnOk_Click(object sender, RoutedEventArgs e)
        {

        }

        private void btnClose_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void xamDataGrid1_CellActivating(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatingEventArgs e)
        {

            string value = Convert.ToString(e.Cell.Record.Cells["CourseID"].Value);

            DataView dv = objDs.Tables[1].DefaultView;
            dv.RowFilter = "CourseID = '" + value + "'";
            xamDataGrid2.DataSource = dv;
          
        }

        private void xamDataGrid1_EditModeEnded(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndedEventArgs e)
        {

        }
        public static Boolean IsValidData(String value)
        {

            //check if special characters are present in the input.
            Char[] arrCode = value.ToCharArray();
            for (int i = 0; i < arrCode.Length; i++)
            {
                int iAscii = Convert.ToInt32(arrCode[i]);
                if (!(iAscii >= 65 && iAscii <= 90) && !(iAscii >= 97 && iAscii <= 122) && !(iAscii >= 48 && iAscii <= 57) && !(iAscii == 95) && !(iAscii == 32))
                {
                    return false;
                }
            }
            return true;


        }

        bool _isModValid = false;


        private bool ModuleNameExists(string name)
        {
            if (objDs.Tables[0].Select("CourseName = '" + name + "'").Length > 0)
                return true;
            else
                return false;
        }

        private void xamDataGrid1_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
        {

            string value = Convert.ToString(e.Editor.Value);

            if (!String.IsNullOrEmpty(Convert.ToString(e.Editor.Value, CultureInfo.InvariantCulture).Trim()))
            {
                if (xamDataGrid1.FieldLayoutSettings.AllowAddNew == true)
                {

                    if (IsValidData(value) == false)
                    {
                        MessageBox.Show("Label can not be special character", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
                        e.Editor.Value = e.Cell.Value;
                        _isModValid = false;
                        return;
                    }
                    if (ModuleNameExists(value) == false)
                    {

                        if (true)
                        {


                        }
                        else
                        {

                        }
                    }
                    else
                    {
                        if (!e.Force)   
                            e.Cancel = true;
                        e.Cell.IsSelected = true;
                        e.Cell.IsActive = true;
                        e.Editor.Value = e.Cell.Value;

                        MessageBox.Show("This label is already being used, please enter a different module label", "Label already exist", MessageBoxButton.OK, MessageBoxImage.Error);
                        e.Editor.Value = e.Cell.Value;
                        if (!e.Force)   
                            e.Cancel = true;
                        _isModValid = false;
                    }
                }
                else
                {
                  
                    if (e.Cell.Value.ToString().Trim() != e.Editor.Value.ToString().Trim())
                    {
                      
                        if (IsValidData(e.Editor.Value.ToString().Trim()) == true)
                        {
                            if (ModuleNameExists(value) == false)
                            {

                            }
                            else
                            {
                                MessageBox.Show("This label is already being used, please enter a different module label", "Label already exist", MessageBoxButton.OK, MessageBoxImage.Error);
                                e.Editor.Value = e.Cell.Value;
                                _isModValid = false;

                            }
                        }
                        else
                        {
                            MessageBox.Show("Label can not be special character", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
                            e.Editor.Value = e.Cell.Value;
                            _isModValid = false;
                        }
                     
                    }
                }
            }
            else  
            {
                MessageBox.Show("Label can not be blank", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
                e.Editor.Value = e.Cell.Value;
                _isModValid = false;
            }
        }
        private void xamDataGrid1_EditModeStarted(object sender, Infragistics.Windows.DataPresenter.Events.EditModeStartedEventArgs e)
        {

        }

        private void xamDataGrid1_RecordActivated(object sender, Infragistics.Windows.DataPresenter.Events.RecordActivatedEventArgs e)
        {

        }

        private void xamDataGrid1_RecordUpdated(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs e)
        {

        }

        private void xamDataGrid1_CellUpdated(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {

        }

        private void xamDataGrid1_PreviewKeyDown(object sender, KeyEventArgs e)
        {

        }

        private void xamDataGrid1_SelectedItemsChanged(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs e)
        {

        }

        private void xamDataGrid2_CellActivating(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatingEventArgs e)
        {

        }

        private void xamDataGrid2_CellUpdated(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {

        }

        private void xamDataGrid2_EditModeEnded(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndedEventArgs e)
        {

        }

        private void xamDataGrid2_EditModeStarted(object sender, Infragistics.Windows.DataPresenter.Events.EditModeStartedEventArgs e)
        {

        }

        private void xamDataGrid2_RecordActivated(object sender, Infragistics.Windows.DataPresenter.Events.RecordActivatedEventArgs e)
        {


        }

        private void xamDataGrid2_RecordDeactivating(object sender, Infragistics.Windows.DataPresenter.Events.RecordDeactivatingEventArgs e)
        {

        }

        private void xamDataGrid2_RecordsDeleted(object sender, Infragistics.Windows.DataPresenter.Events.RecordsDeletedEventArgs e)
        {

        }

        private void xamDataGrid2_RecordActivating(object sender, Infragistics.Windows.DataPresenter.Events.RecordActivatingEventArgs e)
        {

        }

        private void xamDataGrid2_RecordsDeleting(object sender, Infragistics.Windows.DataPresenter.Events.RecordsDeletingEventArgs e)
        {

        }

        private void xamDataGrid2_RecordUpdated(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs e)
        {

        }

        private void xamDataGrid2_RecordUpdating(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatingEventArgs e)
        {

        }

        private void xamDataGrid2_EditModeValidationError(object sender, Infragistics.Windows.DataPresenter.Events.EditModeValidationErrorEventArgs e)
        {

        }

        private void xamDataGrid2_KeyDown(object sender, KeyEventArgs e)
        {

        }

        private void tabContainer_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (tabContainer.SelectedIndex == 0)
            {
                InitializeDataTable();
                xamDataGrid1.DataSource = objDs.Tables[0].DefaultView;
            }
            
        }

        private void btnNewCourse_Click(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.FieldLayoutSettings.AllowAddNew = true;
            
            xamDataGrid1.RecordManager.CurrentAddRecord.Cells[1].Value = "New Course " + (objDs.Tables[0].Rows.Count + 1).ToString();
            xamDataGrid1.RecordManager.CurrentAddRecord.Cells[1].IsActive = true;
            xamDataGrid1.RecordManager.CurrentAddRecord.Cells[1].IsSelected = true;
            xamDataGrid1.RecordManager.CurrentAddRecord.Cells[1].DataPresenter.ExecuteCommand(DataPresenterCommands.StartEditMode);


            xamDataGrid1.RecordManager.CurrentAddRecord.Cells[0].Field.Settings.AllowEdit = true;
        }
    }
}
